diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenControllerSetup.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenControllerSetup.java
index db1d1d5eb..a80248113 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenControllerSetup.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenControllerSetup.java
@@ -5,6 +5,7 @@ import net.minecraft.client.input.InputType;
 import net.minecraft.client.input.controller.Button;
 import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.client.input.controller.ControllerType;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.State;
 import net.minecraft.core.lang.I18n;
@@ -176,11 +177,11 @@ public class ScreenControllerSetup extends Screen {
 
     private void save() {
         if (this.mc.controllerInput != null) {
-            this.mc.gameSettings.selectedController.value = this.mc.controllerInput.getGUID();
+            GameSettings.SELECTED_CONTROLLER.value = this.mc.controllerInput.getGUID();
         } else {
-            this.mc.gameSettings.selectedController.value = "";
+            GameSettings.SELECTED_CONTROLLER.value = "";
         }
-        this.mc.gameSettings.saveOptions();
+        GameSettings.saveOptions();
     }
 
     private void drawButton(ControllerInput controller, Button button, int x, int y, boolean pressed) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenHudDesigner.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenHudDesigner.java
index 37d35421e..b213c7a3a 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenHudDesigner.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenHudDesigner.java
@@ -7,6 +7,7 @@ import net.minecraft.client.gui.hud.component.HudComponentMovable;
 import net.minecraft.client.gui.hud.component.layout.LayoutAbsolute;
 import net.minecraft.client.gui.hud.component.layout.Layout;
 import net.minecraft.client.gui.hud.component.layout.LayoutSnap;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.renderer.State;
@@ -36,8 +37,8 @@ public class ScreenHudDesigner
     @Override
     public void init() {
         super.init();
-        this.screenPadding = this.mc.gameSettings.screenPadding.value;
-        this.mc.gameSettings.screenPadding.set(0.0f);
+        this.screenPadding = GameSettings.SCREEN_PADDING.value;
+        GameSettings.SCREEN_PADDING.set(0.0f);
 
         add(new ButtonElement(0, this.width / 2 - 100, this.height - BOTTOM_SPACE + (BOTTOM_SPACE - 20) / 2, 178, 20, I18n.getInstance().translateKey("gui.hud_designer.button.done")));
         add(this.resetButton = new ButtonElement(1, this.width / 2 + 80, this.height - BOTTOM_SPACE + (BOTTOM_SPACE - 20) / 2, 20, 20, "")
@@ -47,7 +48,7 @@ public class ScreenHudDesigner
     @Override
     public void removed() {
         super.removed();
-        this.mc.gameSettings.screenPadding.set(this.screenPadding);
+        GameSettings.SCREEN_PADDING.set(this.screenPadding);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenLabelEditor.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenLabelEditor.java
index 86d3d761a..f0f276e61 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenLabelEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenLabelEditor.java
@@ -4,6 +4,7 @@ import net.minecraft.client.gui.keyboard.ScreenKeyboard;
 import net.minecraft.client.gui.text.ITextField;
 import net.minecraft.client.gui.text.TextFieldEditor;
 import net.minecraft.client.input.InputType;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
@@ -42,7 +43,7 @@ public class ScreenLabelEditor extends Screen implements ITextField {
     @Override
     public void tick() {
         this.cursorCounter++;
-        if ((this.mc.gameSettings.forceOnscreenKeyboard.value || this.mc.inputType == InputType.CONTROLLER) && !(this.mc.currentScreen instanceof ScreenKeyboard)) {
+        if ((GameSettings.FORCE_ONSCREEN_KEYBOARD.value || this.mc.inputType == InputType.CONTROLLER) && !(this.mc.currentScreen instanceof ScreenKeyboard)) {
             buttonClicked(this.buttons.get(0)); // Close out of gui when exiting keyboard screen
         }
     }
@@ -92,14 +93,11 @@ public class ScreenLabelEditor extends Screen implements ITextField {
         Keyboard.enableRepeatEvents(true);
         this.buttons.add(new ButtonElement(0, this.width / 2 - 100, this.height / 4 + 120, I18n.getInstance().translateKey("gui.edit_label.button.done")));
 
-        if (this.mc.gameSettings.forceOnscreenKeyboard.value || this.mc.inputType == InputType.CONTROLLER) {
+        if (GameSettings.FORCE_ONSCREEN_KEYBOARD.value || this.mc.inputType == InputType.CONTROLLER) {
             this.mc.displayScreen(new ScreenKeyboard(this, this.editor,
-                (s) -> {
-                },
-                (c, k, s) -> {
-                },
-                s -> {
-                }));
+                (s) -> {},
+                (c, k, s) -> {},
+                s -> {}));
         }
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
index d44c7b9e0..106f1b9ce 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
@@ -1,25 +1,15 @@
 package net.minecraft.client.gui;
 
-import java.awt.image.BufferedImage;
-import java.io.BufferedReader;
-import java.io.InputStream;
-import java.io.InputStreamReader;
-import java.nio.charset.StandardCharsets;
-import java.text.SimpleDateFormat;
-import java.util.ArrayList;
-import java.util.Date;
-import java.util.List;
-import java.util.Random;
-
-import javax.crypto.Cipher;
-import javax.imageio.ImageIO;
-
 import com.mojang.logging.LogUtils;
+import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.error.ScreenMissingJCE;
 import net.minecraft.client.gui.hud.HudIngame;
 import net.minecraft.client.gui.hud.HudIngameDoom;
+import net.minecraft.client.gui.options.ScreenOptions;
+import net.minecraft.client.gui.options.data.OptionsPages;
 import net.minecraft.client.gui.server.ScreenSelectServer;
 import net.minecraft.client.holiday.Holidays;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
@@ -32,21 +22,30 @@ import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.util.helper.UrlHelper;
 import net.minecraft.core.Version;
-import org.jetbrains.annotations.NotNull;
-import org.joml.Math;
-import org.lwjgl.input.Keyboard;
-
-import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.options.ScreenOptions;
-import net.minecraft.client.gui.options.data.OptionsPages;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.joml.Math;
+import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL41;
 import org.slf4j.Logger;
 
+import javax.crypto.Cipher;
+import javax.imageio.ImageIO;
+import java.awt.image.BufferedImage;
+import java.io.BufferedReader;
+import java.io.InputStream;
+import java.io.InputStreamReader;
+import java.nio.charset.StandardCharsets;
+import java.text.SimpleDateFormat;
+import java.util.ArrayList;
+import java.util.Date;
+import java.util.List;
+import java.util.Random;
+
 public class ScreenMainMenu extends Screen {
     private static final Logger LOGGER = LogUtils.getLogger();
 
@@ -194,7 +193,7 @@ public class ScreenMainMenu extends Screen {
                 } catch (final Exception ignored) {
                     hasJCE = false;
                 }
-                if (!(hasJCE) && this.mc.gameSettings.doJCECheck.value) {
+                if (!(hasJCE) && GameSettings.DO_JCE_CHECK.value) {
                     this.mc.displayScreen(new ScreenMissingJCE(this, new ScreenSelectServer(this)));
                 } else {
                     this.mc.displayScreen(new ScreenSelectServer(this));
@@ -236,7 +235,7 @@ public class ScreenMainMenu extends Screen {
 
     @Override
     public void renderTexturedBackground() {
-        if (this.mc.mainMenuBackground.isEnabled() && !this.mc.gameSettings.alphaMenu.value) {
+        if (this.mc.mainMenuBackground.isEnabled() && !GameSettings.ALPHA_MENU.value) {
             this.mc.mainMenuBackground.draw();
         } else {
             super.renderTexturedBackground();
@@ -257,7 +256,7 @@ public class ScreenMainMenu extends Screen {
             }
         }
 
-        if (this.mc.gameSettings.playTitleScreenMusic.value) {
+        if (GameSettings.PLAY_TITLE_SCREEN_MUSIC.value) {
             this.mc.sndManager.playTitleScreenMusic();
         }
     }
@@ -273,8 +272,8 @@ public class ScreenMainMenu extends Screen {
         if (mx >= logoX + p && mx <= logoX + 270 - p && my >= logoHeight + p && my <= logoHeight + 48 - p) {
             if (this.logoClickCounter >= 0) {
                 this.indexToDraw = rand.nextInt(BLOCKS_TO_DRAW.length);
-                this.mc.gameSettings.alphaMenu.toggle();
-                if (this.mc.gameSettings.alphaMenu.value) this.logoBlocks = null;
+                GameSettings.ALPHA_MENU.toggle();
+                if (GameSettings.ALPHA_MENU.value) this.logoBlocks = null;
                 this.logoClickCounter = 0;
             } else {
                 this.logoClickCounter++;
@@ -294,7 +293,7 @@ public class ScreenMainMenu extends Screen {
         int c = 274;
         int k = this.width / 2 - c / 2;
         byte byte0 = 30;
-        if (!this.mc.gameSettings.alphaMenu.value) {
+        if (!GameSettings.ALPHA_MENU.value) {
             this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/title/mclogo.png").bind();
             GLRenderer.setColor4f(1f, 1f, 1f, 1f);
             drawTexturedModalRect(k, byte0, 0, 0, 274, 50, 1d / 274, 1d / 50);
@@ -320,7 +319,7 @@ public class ScreenMainMenu extends Screen {
         GLRenderer.modelM4f().scale(scalar, scalar, scalar);
         drawStringCenteredShadow(this.fontRenderer, this.splashText, 0, -8, 0xffff00);
         GLRenderer.popFrame();
-        int versionTextColor = this.mc.gameSettings.alphaMenu.value || !this.mc.mainMenuBackground.isEnabled() ? 0x505050 : 0xFFFFFF;
+        int versionTextColor = GameSettings.ALPHA_MENU.value || !this.mc.mainMenuBackground.isEnabled() ? 0x505050 : 0xFFFFFF;
         if (this.showBuildTime) {
             drawStringShadow(this.fontRenderer, this.buildTimeString, 2, 2, versionTextColor);
         } else {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
index 3f70c7f8b..7018b3aa5 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
@@ -208,7 +208,7 @@ public class ScreenPhotoMode extends Screen {
             if (this.desiredSeason == -1) {
                 this.desiredDay = this.originalTOD / Global.DAY_LENGTH_TICKS;
             } else {
-                this.desiredDay = (long) Global.DAY_LENGTH_TICKS * 7 * this.desiredSeason + Global.DAY_LENGTH_TICKS * 3L;
+                this.desiredDay = (long) Global.DAY_LENGTH_TICKS * 14 * this.desiredSeason + Global.DAY_LENGTH_TICKS * 3L;
             }
 
             this.mc.currentWorld.setWorldTimeUpdateTicks(this.desiredDay + this.desiredTOD);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
index 7fb04b990..ace3a5240 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
@@ -4,6 +4,7 @@ import net.minecraft.client.gui.keyboard.ScreenKeyboard;
 import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
 import net.minecraft.client.input.InputType;
 import net.minecraft.client.input.controller.ControllerInput;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.TileEntityRenderDispatcher;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.State;
@@ -69,7 +70,7 @@ public class ScreenSignEditor extends Screen {
                 this.inKeyboard = true;
             })).mute().hide();
 
-        this.inKeyboard = (this.mc.gameSettings.forceOnscreenKeyboard.value || this.mc.inputType == InputType.CONTROLLER) && !(this.mc.currentScreen instanceof ScreenKeyboard);
+        this.inKeyboard = (GameSettings.FORCE_ONSCREEN_KEYBOARD.value || this.mc.inputType == InputType.CONTROLLER) && !(this.mc.currentScreen instanceof ScreenKeyboard);
     }
 
     @Override
@@ -135,7 +136,7 @@ public class ScreenSignEditor extends Screen {
     @Override
     public void render(int mx, int my, float partialTick) {
         GLRenderer.setColor4f(1f, 1f, 1f, 1f);
-        if (this.inKeyboard && (this.mc.gameSettings.forceOnscreenKeyboard.value || this.mc.inputType == InputType.CONTROLLER) && !(this.mc.currentScreen instanceof ScreenKeyboard)) {
+        if (this.inKeyboard && (GameSettings.FORCE_ONSCREEN_KEYBOARD.value || this.mc.inputType == InputType.CONTROLLER) && !(this.mc.currentScreen instanceof ScreenKeyboard)) {
             if (this.editLine < this.entitySign.signText.length) {
                 ScreenKeyboard keyboard = new ScreenKeyboard(this, null,
                     (s) -> {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenSoundTest.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenSoundTest.java
index f8719f5ed..b07dac7ac 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenSoundTest.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenSoundTest.java
@@ -107,7 +107,7 @@ public class ScreenSoundTest extends Screen {
         add(new ListenerButtonElement(32, 40 + BUTTON_SPACING * 3, this.bottom - (BUTTON_SPACING + 20), 40, 20, I18n.getInstance().translateKey("gui.sound_test.button.reload")))
             .setActionListener(() -> {
                 this.mc.sndManager = new SoundEngine();
-                this.mc.sndManager.init(this.mc.gameSettings);
+                this.mc.sndManager.init();
                 initRepos();
             });
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/TextFieldElement.java b/game/client/src/main/java/net/minecraft/client/gui/TextFieldElement.java
index 9bceeabe6..f30db0ad2 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/TextFieldElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/TextFieldElement.java
@@ -4,6 +4,7 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.keyboard.ScreenKeyboard;
 import net.minecraft.client.gui.text.TextFieldEditor;
 import net.minecraft.client.input.InputType;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.window.CursorShape;
 import net.minecraft.core.util.helper.MathHelper;
@@ -29,12 +30,12 @@ public class TextFieldElement extends Gui implements ITextField
 	private ITextChangeListener textChangeListener;
     private String placeholder;
     public boolean drawBackground = true;
-    private TextFieldEditor editor;
+    private final TextFieldEditor editor;
 
     public TextFieldElement(@Nullable Screen parent, FontRenderer fontRenderer, int xPosition, int yPosition, int width, int height, String defaultText, String placeholder)
     {
-        isFocused = false;
-        isEnabled = true;
+        this.isFocused = false;
+        this.isEnabled = true;
         this.parent = parent;
         this.fontRenderer = fontRenderer;
         this.xPosition = xPosition;
@@ -44,25 +45,25 @@ public class TextFieldElement extends Gui implements ITextField
         this.editor = new TextFieldEditor(this);
         this.placeholder = placeholder;
         setText(defaultText);
-        editor.setCursor(10000);
+        this.editor.setCursor(10000);
     }
 
     @Override
     public void setText(String text)
     {
-        if (text == null) editor.setCursor(0);
-        else if (text.length() < editor.getCursor())
+        if (text == null) this.editor.setCursor(0);
+        else if (text.length() < this.editor.getCursor())
         {
-            editor.setCursor(text.length());
+            this.editor.setCursor(text.length());
         }
         this.text = text;
-        if(textChangeListener != null) textChangeListener.textChanged(this);
+        if(this.textChangeListener != null) this.textChangeListener.textChanged(this);
     }
 
     @Override
     public String getText()
     {
-        return text;
+        return this.text;
     }
 
     public void setPlaceholder(String placeholder) {
@@ -71,30 +72,30 @@ public class TextFieldElement extends Gui implements ITextField
 
     public void updateCursorCounter()
     {
-        cursorCounter++;
+        this.cursorCounter++;
     }
 
     public void textboxKeyTyped(char c, int key)
     {
-        if(!isEnabled || !isFocused)
+        if(!this.isEnabled || !this.isFocused)
         {
             return;
         }
         if(key == Keyboard.KEY_TAB) {
-            if (parent != null) {
-                parent.selectNextField();
+            if (this.parent != null) {
+                this.parent.selectNextField();
             }
         }
-        if(editor.handleInput(key, c)) {
-        	if(textChangeListener != null) textChangeListener.textChanged(this);
+        if(this.editor.handleInput(key, c)) {
+        	if(this.textChangeListener != null) this.textChangeListener.textChanged(this);
         }
     }
 
     public void mouseClicked(int x, int y, int mouseButton)
     {
         boolean hovered = isHovered(x, y);
-        if (parent != null && ((Minecraft.getMinecraft().inputType == InputType.CONTROLLER || Minecraft.getMinecraft().gameSettings.forceOnscreenKeyboard.value) && hovered && mouseButton == 0)) {
-            this.parent.mc.displayScreen(new ScreenKeyboard(parent, editor, s -> {}, (c, k, workingString) -> {}, s -> {}));
+        if (this.parent != null && ((Minecraft.getMinecraft().inputType == InputType.CONTROLLER || GameSettings.FORCE_ONSCREEN_KEYBOARD.value) && hovered && mouseButton == 0)) {
+            this.parent.mc.displayScreen(new ScreenKeyboard(this.parent, this.editor, s -> {}, (c, k, workingString) -> {}, s -> {}));
         } else {
             setFocused(hovered);
             if(hovered && mouseButton == 1) {
@@ -104,21 +105,21 @@ public class TextFieldElement extends Gui implements ITextField
     }
 
     public boolean isHovered(int x, int y) {
-        return isEnabled && x >= xPosition && x < xPosition + width && y >= yPosition && y < yPosition + height;
+        return this.isEnabled && x >= this.xPosition && x < this.xPosition + this.width && y >= this.yPosition && y < this.yPosition + this.height;
     }
 
     public void setFocused(boolean flag)
     {
-        if(flag && !isFocused)
+        if(flag && !this.isFocused)
         {
-            cursorCounter = 0;
-            editor.setCursor(10000);
+            this.cursorCounter = 0;
+            this.editor.setCursor(10000);
         }
-        isFocused = flag;
+        this.isFocused = flag;
     }
 
     public void updateCursor(Minecraft mc, int mx, int my) {
-        boolean hovered = isEnabled && mx >= xPosition && mx < xPosition + width && my >= yPosition && my < yPosition + height;
+        boolean hovered = this.isEnabled && mx >= this.xPosition && mx < this.xPosition + this.width && my >= this.yPosition && my < this.yPosition + this.height;
         if (hovered) {
             mc.currentScreen.setDesiredCursor(CursorShape.I_BEAM);
         }
@@ -126,58 +127,58 @@ public class TextFieldElement extends Gui implements ITextField
 
     public void drawTextBox()
     {
-        if (drawBackground)
+        if (this.drawBackground)
         {
-            drawRect(xPosition - 1, yPosition - 1, xPosition + width + 1, yPosition + height + 1, 0xffa0a0a0);
-            drawRect(xPosition, yPosition, xPosition + width, yPosition + height, 0xff000000);
+            drawRect(this.xPosition - 1, this.yPosition - 1, this.xPosition + this.width + 1, this.yPosition + this.height + 1, 0xffa0a0a0);
+            drawRect(this.xPosition, this.yPosition, this.xPosition + this.width, this.yPosition + this.height, 0xff000000);
         }
-        if (text.isEmpty() && !isFocused)
+        if (this.text.isEmpty() && !this.isFocused)
         {
-            drawStringShadow(fontRenderer, placeholder, xPosition + 4, yPosition + (height - 8) / 2, 0x5f5f5f);
+            drawStringShadow(this.fontRenderer, this.placeholder, this.xPosition + 4, this.yPosition + (this.height - 8) / 2, 0x5f5f5f);
         }
 
-        if(isEnabled)
+        if(this.isEnabled)
         {
-            boolean drawCursor = isFocused && (cursorCounter / 6) % 2 == 0;
-            int cursor = editor.getCursor();
-            int maxDisplayableChars = this.width / fontRenderer.getFont().charWidth('_');
+            boolean drawCursor = this.isFocused && (this.cursorCounter / 6) % 2 == 0;
+            int cursor = this.editor.getCursor();
+            int maxDisplayableChars = this.width / this.fontRenderer.getFont().charWidth('_');
 
-            if(text.length() <= maxDisplayableChars-1){
-                drawStringShadow(fontRenderer, text, xPosition + 4, yPosition + (height - 8) / 2, 0xE0E0E0);
+            if(this.text.length() <= maxDisplayableChars-1){
+                drawStringShadow(this.fontRenderer, this.text, this.xPosition + 4, this.yPosition + (this.height - 8) / 2, 0xE0E0E0);
             } else {
                 //only draw the part of the string that's maxDisplayableChars chars around the cursor
                 int begin = Math.max(0,cursor - maxDisplayableChars);
-                int end = Math.max(maxDisplayableChars,Math.min(text.length(),cursor));
-                drawStringShadow(fontRenderer, text.substring(begin, end), xPosition + 4, yPosition + (height - 8) / 2, 0xE0E0E0);
+                int end = Math.max(maxDisplayableChars,Math.min(this.text.length(),cursor));
+                drawStringShadow(this.fontRenderer, this.text.substring(begin, end), this.xPosition + 4, this.yPosition + (this.height - 8) / 2, 0xE0E0E0);
             }
             if (drawCursor)
             {
-                int width = MathHelper.ceil(fontRenderer.stringWidthDouble(text));
-                if (cursor < text.length())
+                int width = MathHelper.ceil(this.fontRenderer.stringWidthDouble(this.text));
+                if (cursor < this.text.length())
                 {
-                    width = MathHelper.ceil(fontRenderer.stringWidthDouble(text.substring(0, cursor)));
+                    width = MathHelper.ceil(this.fontRenderer.stringWidthDouble(this.text.substring(0, cursor)));
                 }
                 if(width >= this.width-4){
                     // width of the text box - the width of the last character
-                    width = (this.width-4) - MathHelper.ceil(fontRenderer.stringWidthDouble(text.substring(text.length()-2,text.length()-1)));
+                    width = (this.width-4) - MathHelper.ceil(this.fontRenderer.stringWidthDouble(this.text.substring(this.text.length()-2, this.text.length()-1)));
                 }
-                drawStringShadow(fontRenderer, "_", xPosition + 4 + width, yPosition + (height - 8) / 2 + 1, 0xE0E0E0);
+                drawStringShadow(this.fontRenderer, "_", this.xPosition + 4 + width, this.yPosition + (this.height - 8) / 2 + 1, 0xE0E0E0);
             }
         }
         else
         {
-            drawStringShadow(fontRenderer, text, xPosition + 4, yPosition + (height - 8) / 2, 0x707070);
+            drawStringShadow(this.fontRenderer, this.text, this.xPosition + 4, this.yPosition + (this.height - 8) / 2, 0x707070);
         }
     }
 
     public void setMaxStringLength(int i)
     {
-        maxStringLength = i;
+        this.maxStringLength = i;
     }
 
 	@Override
     public int maxLength() {
-		return maxStringLength == 0 ? 1000 : maxStringLength;
+		return this.maxStringLength == 0 ? 1000 : this.maxStringLength;
 	}
     
     public void setTextChangeListener(ITextChangeListener textChangeListener) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java b/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
index 9345d8e73..5940c6dc8 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
@@ -7,6 +7,7 @@ import com.google.gson.JsonParser;
 import com.google.gson.stream.JsonReader;
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.CompareFunc;
@@ -123,7 +124,7 @@ public class TooltipElement extends Gui {
     }
 
     private int[] drawBackground(final int minX, final int minY, final int maxX, final int maxY) {
-        final Style style = styleMap.getOrDefault(this.mc.gameSettings.tooltipStyle.value, defaultStyle);
+        final Style style = styleMap.getOrDefault(GameSettings.TOOLTIP_STYLE.value, defaultStyle);
         if (style != null) {
             GLRenderer.pushFrame();
             GLRenderer.setDepthFunc(CompareFunc.ALWAYS);
@@ -155,7 +156,7 @@ public class TooltipElement extends Gui {
         boolean discovered = true;
         boolean ctrlPressed = false;
         boolean shiftPressed = false;
-        boolean debug = this.mc.gameSettings.showItemDebugInfo.value;
+        boolean debug = GameSettings.SHOW_ITEM_DEBUG_INFO.value;
 
         if (slot != null) {
             discovered = slot.getIsDiscovered(this.mc.thePlayer);
@@ -165,7 +166,7 @@ public class TooltipElement extends Gui {
                 shiftPressed = Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) || Keyboard.isKeyDown(Keyboard.KEY_RSHIFT);
 
                 showDescription = false;
-                if (this.mc.gameSettings.swapCraftingButtons.value) {
+                if (GameSettings.SWAP_CRAFTING_BUTTONS.value) {
                     boolean temp = shiftPressed;
                     shiftPressed = ctrlPressed;
                     ctrlPressed = temp;
@@ -214,7 +215,7 @@ public class TooltipElement extends Gui {
                 }
             }
 
-            if (itemStack.isItemStackDamageable() && !showDescription && this.mc.gameSettings.showItemDebugInfo.value) {
+            if (itemStack.isItemStackDamageable() && !showDescription && GameSettings.SHOW_ITEM_DEBUG_INFO.value) {
                 int durability = itemStack.getMaxDamage();
                 int remainingUses = durability - itemStack.getMetadata();
 
@@ -223,8 +224,8 @@ public class TooltipElement extends Gui {
 
             if (showDescription) {
                 text.append('\n').append(formatDescription(itemStack.getItemDescription(), 16));
-            } else if (!(slot instanceof SlotResult) && this.mc.gameSettings.itemDescriptions.value != DescriptionPromptEnum.NEVER_PROMPT) {
-                text.append('\n').append(formatDescription(trans.translateKeyAndFormat("gui.tooltip.prompt.description", this.mc.gameSettings.keyDescription.getKeyName()), 16));
+            } else if (!(slot instanceof SlotResult) && GameSettings.ITEM_DESCRIPTIONS.value != DescriptionPromptEnum.NEVER_PROMPT) {
+                text.append('\n').append(formatDescription(trans.translateKeyAndFormat("gui.tooltip.prompt.description", GameSettings.KEY_DESCRIPTION.getKeyName()), 16));
             }
 
             if (slot instanceof SlotResult) {
@@ -361,8 +362,8 @@ public class TooltipElement extends Gui {
             styleMap.put("default", defaultStyle);
             stylesIdList.add("default");
         }
-        if (Minecraft.getMinecraft().gameSettings.tooltipStyle.getValueIndex() == -1) {
-            Minecraft.getMinecraft().gameSettings.tooltipStyle.set("default");
+        if (GameSettings.TOOLTIP_STYLE.getValueIndex() == -1) {
+            GameSettings.TOOLTIP_STYLE.set("default");
         }
     }
 
